//+------------------------------------------------------------------+
//|                                                         VPCI.mq4 |
//|                                Copyright  2008, Victor Nicolaev |
//|                                            e-mail: vinin@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Victor Nicolaev"
#property link      "e-mail: vinin@mail.ru"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Yellow

//---- input parameters
extern int Period_Slow=50;
extern int Period_Fast=10;
//---- buffers
double VPCI[];



//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,VPCI);
//   SetIndexDrawBegin(0,Period_Slow);
   IndicatorShortName("VPCI");
   SetIndexLabel(0,"VPCI"+"("+Period_Slow+","+Period_Fast+")");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Bulls Power                                                      |
//+------------------------------------------------------------------+
int start() {
   
   int i;
   int ExtCountedBars=IndicatorCounted();
   if (ExtCountedBars<0) return(-1);
   if (ExtCountedBars>0) ExtCountedBars--;
   int limit=Bars-ExtCountedBars-1;
   



   double VPC, VPR, VM,tmp;
      
   for(i=limit; i>=0; i--) {
      double Volume_Slow=sVolume(Period_Slow,i);
      double Volume_Fast=sVolume(Period_Fast,i);
      double VWMA_Slow=VWMA(Period_Slow,i)/Volume_Slow;
      double VWMA_Fast=VWMA(Period_Fast,i)/Volume_Fast;
      double SMA_Slow=iMA(NULL,0,Period_Slow,0,MODE_SMA,PRICE_CLOSE,i);
      double SMA_Fast=iMA(NULL,0,Period_Fast,0,MODE_SMA,PRICE_CLOSE,i);
      
      VPC=VWMA_Slow-SMA_Slow;
     
      VPR=1.0; if (SMA_Fast!=0) VPR=VWMA_Fast/SMA_Fast;
    
      VM=1.0; if (Volume_Slow!=0) VM=(Volume_Fast/Period_Fast)/(Volume_Slow/Period_Slow);
    
      VPCI[i]=VPC*VPR*VM;
//      Print(VPC," ;",VPR," ;",VM," ;",VPCI[i]);
   }
   return(0);
  }
//+------------------------------------------------------------------+



double sVolume(int Count, int Pos){
   int i;
   double sum=0;
   for (i=Pos;i<Pos+Count;i++) sum+=Volume[i];
   return(sum);
}

double VWMA(int Count, int Pos){
   int i;
   double sum=0;
   for (i=Pos;i<Pos+Count;i++) sum+=Close[i]*Volume[i];
   return(sum);
}